% n1 is the provider's number of network 1
% n2 is the provider's number of network 2
% gc1 is the provider's cost of network 1
% gc2 is the provider's cost of network 2
% rc1 is 2*n matrix and the first row is the route cost from network 1 to
% network 2, the second row the minimum hop number of each route
% rc1 is 2*n matrix and the first row is the route cost from network 2 to
% network 1, the second row the minimum hop number of each route
fid = fopen('dataset.dat','r');
n1 = fscanf(fid, '%f', 2);
n1 = n1(2);
gc1 = fscanf(fid, '%f %f', [2,n1]);
gc1 = gc1(2,:);
n2 = fscanf(fid, '%f', 2);
n2 = n2(2);
gc2 = fscanf(fid, '%f %f', [2,n2]);
gc2 = gc2(2,:);

rc1 = zeros(2, n1*n2);
rc2 = zeros(2, n1*n2);

for i=1:n1*n2
    fscanf(fid, '%f %f', [2,1]);
    div = fscanf(fid, '%f', 1);
    hop = fscanf(fid, '%f', div);
    rc1(2,i)=min(hop);
    rc1(1,i)=PCfunction(hop);
end
for i=1:n1*n2
    fscanf(fid, '%f %f', [2,1]);
    div = fscanf(fid, '%f', 1);
    hop = fscanf(fid, '%f', div);
    rc2(2,i)=min(hop);
    rc2(1,i)=PCfunction(hop);
end

fclose(fid);