function p=GenPotentialGameMatrix(M1,M2)
% M1 is the cost of network 1
% M2 is the cost of network 2
p=zeros(size(M1));
len=size(M1,1);
% set p(1,1)=0 instead of setting the global minimum to save calculation
for i=2:len
    p(i,1)=p(i-1,1)+M1(i,1)-M1(i-1,1);
end
for i=1:len
    for j=2:len
        p(i,j)=p(i,j-1)+M2(i,j)-M2(i,j-1);
    end
end
