 //before running, clean all routing tables in oix/ with:
/**
sed -e 's/\/30/\/30 /' oix-full-snapshot-2009-12-22-1800 > rt2.dat
sed -e 's/\/32/\/32 /' rt2.dat > rt3.dat
sed -e 's/\/28/\/28 /' rt3.dat > rt2.dat
sed -e 's/\/29/\/29 /' rt2.dat > rt3.dat
sed -e 's/\/31/\/31 /' rt3.dat > rt2.dat
sed -e 's/\/28/\/28 /' rt2.dat > rt3.dat
sed -e 's/\/27/\/27 /' rt3.dat > rt2.dat
sed -e 's/\/24/\/24 /' rt2.dat > rt3.dat
sed -e 's/\/25/\/25 /' rt3.dat > rt2.dat
sed -e 's/\/26/\/26 /' rt2.dat > rt3.dat
sed -e 's/\/21/\/21 /' rt2.dat > rt3.dat
sed -e 's/\/22/\/22 /' rt3.dat > rt2.dat
sed -e 's/\/19/\/19 /' rt2.dat > rt3.dat
sed -e 's/\/23/\/23 /' rt3.dat > rt2.dat
sed -e 's/{/ /' rt2.dat > rt3.dat
sed -e 's/}/ /' rt3.dat > rt2.dat
sed -e 's/,/ /' rt2.dat > rt3.dat
sed -e 's/,/ /' rt3.dat > rt2.dat
cat rt2 | tr ',' ' ' > oix-full-snapshot-2009-12-22-1800

*/
#include <math.h>
#include <time.h>
#include <ctime>
#include <stdio.h>
#include <stdlib.h>
#include <cstdlib>
#include <algorithm>
#include <limits.h>
#include <cstring>
#include <string>
#include <string.h>
#include <iostream>
using std::string;
using namespace std;

#define MAXSTUB 70000
#define MAXPROVIDER 70
#define MAXPATHS 1000
#define MAXPATHLEN 30

/*
                 struct stubAS
                 {
                     bool is;
                     int** as_content;
                     int line;
                 };
 * */


 void aspair(int source , int destination,int **pathlist, string bgprt);
 void asproviders(int source , int destination,int *providerlista,int *providerlistb,string bgprt, string provlist, FILE* filelist);
 void complete(int sourceprov, int destprov, FILE* filelist, string bgprt);

 int main(int* argc, char* argv[]){

	//string bgprt("rt3.dat");
        string res("res-paths.dat");
        string plist("p-list.dat");        
        string rtlistname("rtlist");

        FILE* filelist;        
        int *providerlista=NULL;        int *providerlistb=NULL;
        
        int i,j,k,y,x,ww,kk,yy;
        char bufzone[150];

        providerlista=new int [MAXPROVIDER];
        for (i=0;i<MAXPROVIDER;i++)            providerlista[i]=0;
        providerlistb=new int [MAXPROVIDER];       
        for (i=0;i<MAXPROVIDER;i++)            providerlistb[i]=0;

       //getting the passed edge AS source and dest
       string source(argv[1]);       string destination(argv[2]);

       string execcommand = "ls oix/oix-* > " +rtlistname;
       system(execcommand.c_str());

      

           int countrt=0;
           while(countrt<250){
                countrt=countrt+1;
                char result[100];
 filelist= fopen(rtlistname.c_str(),"r");
       if (filelist==NULL)
       {
            printf("the file can not be opened\n");    	exit(3);
       }
       else
       {
                sprintf(result, "%d", countrt );
                for (i=0; i<countrt;i++) fscanf(filelist,"%s",bufzone);
                if (strcmp(bufzone,"end")==0) exit(99);
         if (countrt>175) {  //countrt check only to run after a given routing table in the list - useful to restart in case of past errors with previos
              	
                string bgprt=  string(bufzone); //string("oix/") +
                //string bgprt= string(bufzone);
                string datasetfilename = string("dataset") + string(result);
                printf("Current routing table %d: %s\t dataset filename: %s\n",countrt,bgprt.c_str(),datasetfilename.c_str());



       //opening dataset sol file for the current routing table
       filelist= fopen(datasetfilename.c_str(),"w");
       if (filelist==NULL)
       {
            printf("the file can not be opened\n");    	exit(3);
       }
       else
       {        
        //get the provider lists for S/D - and print the associated path prepending

        for (i=0;i<MAXPROVIDER;i++)            providerlista[i]=0;
        providerlistb=new int [MAXPROVIDER];
        for (i=0;i<MAXPROVIDER;i++)            providerlistb[i]=0;
        asproviders(atoi(source.c_str()), atoi(destination.c_str()),providerlista,providerlistb,bgprt,datasetfilename,filelist);

        printf("Providers of %d\n",atoi(source.c_str()));
        for (i=0;i<MAXPROVIDER;i++)
             if (providerlista[i]!=0) printf("%d\t",providerlista[i]);
        printf("\nProviders of %d\n",atoi(destination.c_str()));
        for (j=0;j<MAXPROVIDER;j++)
             if (providerlistb[j]!=0) printf("%d\t",providerlistb[j]);
        
        for (i=0;i<MAXPROVIDER;i++)//MAXPROVIDER
            for (j=0;j<MAXPROVIDER;j++)
                if (providerlistb[j]!=0 && providerlista[i]!=0){  //for every source-dest pair of providers
                    printf("\npair %d-%d\n",providerlista[i],providerlistb[j]);
                    complete(providerlista[i],providerlistb[j],filelist,bgprt);
                    //i=100; j=100;
        }
        for (j=0;j<MAXPROVIDER;j++)
        	for (i=0;i<MAXPROVIDER;i++)            
                if (providerlistb[j]!=0 && providerlista[i]!=0){  //for every source-dest pair of providers
                    printf("pair %d-%d\n",providerlistb[j],providerlista[i]);
                    complete(providerlistb[j],providerlista[i],filelist,bgprt);
        }        
        
        printf("\nEnd of dataset filling for %s\n",bgprt.c_str());
        fclose(filelist);
       }
                  }
        } //open rtlist
       }//while rtlist/countr
 }



 void complete(int sourceprov, int destprov, FILE* filelist, string bgprt){
        int i,j,k,y,x,ww,kk,yy;
        int **pathlist=NULL;
        int **pathSD=NULL;

        int nbpathSD=0;
        pathSD = new int*[MAXPATHS];
        for (i=0;i<MAXPATHS;i++)        pathSD[i]=new int[MAXPATHLEN];
        for (i=0;i<MAXPATHS;i++)
            for (j=0;j<MAXPATHLEN;j++)  pathSD[i][j]=0;

        pathlist = new int*[2*MAXPATHS+2];
        for (i=0;i<2*MAXPATHS+2;i++)    pathlist[i]=new int[MAXPATHLEN];
        for (i=0;i<2*MAXPATHS+2;i++)
            for (j=0;j<MAXPATHLEN;j++)  pathlist[i][j]=0;


if (sourceprov!=destprov){

        fprintf(filelist,"%d\t%d\n",sourceprov,destprov); //gateway-locator pair
        //collect all the paths between the given pair of providers
        aspair(sourceprov, destprov, pathlist, bgprt);
 
        printf("Available paths: Source: %d\t Destination:%d ",pathlist[2*MAXPATHS+1][0],pathlist[2*MAXPATHS+1][1]-MAXPATHS);
        //getchar();

        //find the paths from source to destination ptoviders
        int listS,listD,prepdest,prepsource;
        listS=0; listD=0; nbpathSD=0;
        for (i=0;i<pathlist[2*MAXPATHS+1][0];i++){
            prepsource=0;
           //count the source path lenght
           listS=0;
           for (k=0;k<MAXPATHLEN;k++)
               if (pathlist[i][k]!=0) listS=listS+1;

           for (j=MAXPATHS;j<pathlist[2*MAXPATHS+1][1];j++){
               prepdest=0;
               //count the destination path lenght
               listD=0;
               for (k=0;k<MAXPATHLEN;k++)
                   if (pathlist[j][k]!=0) listD=listD+1;
               //count the best AS path lenght
               int lensp=0;
               for (k=0;k<MAXPATHLEN;k++)
                    if (pathlist[2*MAXPATHS][k]!=0) lensp=lensp+1;
               if (lensp==0) lensp=MAXPATHLEN;

               //check all the possible paths and save only if best
               for (k=listS-1;k>-1;k--){
                        for (y=listD-2;y>-1;y--){
                           if (pathlist[i][k]==pathlist[j][y]){
                              for (ww=0;ww<MAXPATHLEN;ww++)     pathSD[nbpathSD][ww]=0;
                              int nbAS=0;
                              //copy the path from the source to the intersection in the best path space pathlist[2*MAXPATHS]
                              for (kk=listS-1;kk>=k;kk--)
                                  //if (pathlist[i][kk]!=pathlist[i][kk+1])
                                  {
                                      //printf("a%d\t",pathlist[i][kk]);
                                      pathSD[nbpathSD][nbAS]=pathlist[i][kk];
                                      nbAS=nbAS+1;
                                  }
                              //copy the path from the intersection to the destination in the best path space pathlist[2*MAXPATHS]
                              for (yy=y+1;yy<listD;yy++)
                                  //if (pathlist[j][yy]!=pathlist[j][yy-1])
                                  {
                                      //printf("b%d\t",pathlist[j][yy]);
                                      pathSD[nbpathSD][nbAS]=pathlist[j][yy];
                                      nbAS=nbAS+1;
                                  }
                              //printf("\n");
                              bool equal=false;
                              for (x=0;x<nbpathSD;x++){
                                  equal=true;
                                  for (ww=0;ww<MAXPATHLEN;ww++)
                                    if (pathSD[x][ww]!=pathSD[nbpathSD][ww]) equal=false;
                                  if (equal) x=nbpathSD+1;
                              }
                              if (!equal){
                                    //printf("%d: ",nbpathSD+1);
                                    //for (ww=0;ww<MAXPATHLEN;ww++) if (pathSD[nbpathSD][ww]!=0) printf("%d\t",pathSD[nbpathSD][ww]);
                                    //printf("\n");
                                    nbpathSD=nbpathSD+1;
                              } else for (ww=0;ww<MAXPATHLEN;ww++)     pathSD[nbpathSD][ww]=0;
                              //else printf("equal\n");//new pair of lines
                              k=-1;y=-1;
                           }
                     }
               }
           }
        }


                        printf("\t S-D provider paths=%d\n",nbpathSD);//getchar();


                        fprintf(filelist,"%d\n",nbpathSD); //nb of S/D paths
                        int count=0;
                        for (k=0;k<nbpathSD;k++){
                            count=0;
                            for (y=0;y<MAXPATHLEN;y++) if (pathSD[k][y]!=0) count=count+1;
                            fprintf(filelist,"%d\n",count); //lenght of each path
                            //printf("%d\n",count);
                            count=0;
                        }
                     } else fprintf(filelist,"%d\t%d\n1\n1\n",sourceprov,destprov);
                     //end of pair of providers



                
 }


void aspair(int source, int destination,int **pathlist, string bgprt){

	FILE *filert;
        char bufzone1[50];
        int* tmplist;
        int i,j,k,kk,list,lineS,lineD;

        tmplist=new int[MAXPATHLEN];
        for (j=0;j<MAXPATHLEN;j++)  tmplist[j]=0;

        filert= fopen(bgprt.c_str(),"r");
        if (filert==NULL)
        {
            printf("the file can not be opened\n");    	exit(3);
        } else {

            lineS=0;lineD=MAXPATHS;

            fscanf(filert,"%s", bufzone1);
            while (strcmp(bufzone1,"Path")!=0)
                fscanf(filert,"%s", bufzone1);
            fscanf(filert,"%s", bufzone1);

            while (strcmp(bufzone1,"*")==0)
            {
                fscanf(filert,"%s", bufzone1);fscanf(filert,"%s", bufzone1);fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);fscanf(filert,"%s", bufzone1);fscanf(filert,"%s", bufzone1);

                list=0;
                bool goforest=true;
                if (lineS>=MAXPATHS || lineD>=2*MAXPATHS) //if no ;ore space available for paths, stop collecting them
                {
                    //break;
                    goforest=false;
                }
		while (goforest)
                {
                    if (strcmp(bufzone1,"i")!=0 && strcmp(bufzone1,"e")!=0 && strcmp(bufzone1,"?")!=0)
                    {
                                tmplist[list]=atoi(bufzone1);
                                fscanf(filert,"%s", bufzone1);
                                list ++;
                    }   else
                    {
                        bool oneequal=true;
                        //printf("in lineS=%d lineD=%d",lineS,lineD);fflush(stdout);
                                if ((tmplist[list-1]==source)&&list>1)//(source!= tmplist[0]))
                                {
                                    for (k=0;k<=lineS;k++){
                                        oneequal=true;
                                        for (j=0;j<list;j++)
                                            if (pathlist[k][j]!=tmplist[j]) oneequal=false;
                                        if (oneequal)   k=lineS+1;
                                    }
                                    if (!oneequal){
                                        for (j=0;j<list;j++)                             pathlist[lineS][j]=tmplist[j];
                                        lineS=lineS+1;
                                    } 
                                    //printf("lineS=%d\n",lineS); getchar();
                                }
                                if ((tmplist[list-1] == destination)&&list>1)//&&(destination!= tmplist[0]))
                                {                                    
                                    for (k=MAXPATHS;k<=lineD;k++){
                                        oneequal=true;
                                        for (j=0;j<list;j++)
                                            if (pathlist[k][j]!=tmplist[j]) oneequal=false;
                                        if (oneequal)   k=lineD+1;
                                    }
                                    if (!oneequal){
                                        for (j=0;j<list;j++)                             pathlist[lineD][j]=tmplist[j];
                                        lineD=lineD+1;
                                    }
                                }
                                fscanf(filert,"%s",bufzone1);
                                goforest=false;
                       //printf("out\n");fflush(stdout);
                            }
                }
          }
            //printf("oh ");getchar();
            if ((lineS==0)||(lineD==0)){
                printf("No paths between for S/D AS %d-%d . %d-%d. RT %s\n",source,destination,lineS,lineD,bgprt.c_str());
                exit(99);
            }
            pathlist[2*MAXPATHS+1][0]=lineS;
            pathlist[2*MAXPATHS+1][1]=lineD;
            //printf("ho "); getchar();
        }

fclose(filert);
 }




void asproviders(int source, int destination,int *providerlista,int *providerlistb, string bgprt, string provlist,FILE *filelist){

    int i,j,k,kk,list,lineS,lineD;
    int **pathlist=NULL;
        int **pathSD=NULL;

        int nbpathSD=0;
        pathSD = new int*[MAXPATHS];
        for (i=0;i<MAXPATHS;i++)        pathSD[i]=new int[MAXPATHLEN];
        for (i=0;i<MAXPATHS;i++)
            for (j=0;j<MAXPATHLEN;j++)  pathSD[i][j]=0;

        pathlist = new int*[2*MAXPATHS+2];
        for (i=0;i<2*MAXPATHS+2;i++)    pathlist[i]=new int[MAXPATHLEN];
        for (i=0;i<2*MAXPATHS+2;i++)
            for (j=0;j<MAXPATHLEN;j++)  pathlist[i][j]=0;



    aspair( source,  destination,pathlist,  bgprt);

    int *prependprov= new int[MAXPROVIDER];;
    for (j=0;j<MAXPROVIDER;j++) prependprov[j]=0;

    printf("Number of available paths. Source: %d\t Destination:%d\n",pathlist[2*MAXPATHS+1][0],pathlist[2*MAXPATHS+1][1]-MAXPATHS);

        int countb=0;
        int prepend=0;
        int nbprova,nbprovb;
        nbprova=0;nbprovb=0;
        for (i=0;i<pathlist[2*MAXPATHS+1][0];i++){
            countb=0;
            prepend=0;
            for (j=0;j<MAXPATHLEN;j++)
                    if (pathlist[i][j]!=0) countb=countb+1;

            while (pathlist[i][countb-1]==pathlist[i][countb-2]) {
                prepend=prepend+1;
                countb=countb-1;
            }

            bool pfound=false;
            for (j=0;j<nbprova;j++){
                if (providerlista[j]==pathlist[i][countb-2]) {
                    pfound=true;
                    if (prependprov[j]<prepend) prependprov[j]=prepend;
                }
            }

            if (!pfound) {
                providerlista[nbprova]=pathlist[i][countb-2];
                prependprov[nbprova]=prepend;
                nbprova=nbprova+1;
                //printf("%d\t%d\n",pathlist[i][countb-2],prepend);getchar();
            }
        }


        nbprovb=0;

        for (i=MAXPATHS;i<pathlist[2*MAXPATHS+1][1];i++){

            countb=0;
            prepend=0;
            for (j=0;j<MAXPATHLEN;j++)
                    if (pathlist[i][j]!=0) countb=countb+1;

            while (pathlist[i][countb-1]==pathlist[i][countb-2]) {
                prepend=prepend+1;
                countb=countb-1;
            }

            bool pfound=false;
            for (j=0;j<nbprovb;j++){
                if (providerlistb[j]==pathlist[i][countb-2]) {
                    pfound=true;
                    if (prependprov[j]<prepend) prependprov[j]=prepend;
                }
            }

            if (!pfound) {
                providerlistb[nbprovb]=pathlist[i][countb-2];
                prependprov[nbprovb]=prepend;
                nbprovb=nbprovb+1;
                //printf("%d\t%d\n",pathlist[i][countb-2],prepend);getchar();
            }
            
        }

        fprintf(filelist,"%d\n%d\n",source,nbprova);
        for (j=0;j<MAXPROVIDER;j++)
            if (providerlista[j]!=0)
                fprintf(filelist,"%d\t%d\n",providerlista[j],prependprov[j]);

        fprintf(filelist,"%d\n%d\n",destination,nbprovb);
        for (j=0;j<MAXPROVIDER;j++)
            if (providerlistb[j]!=0)
                fprintf(filelist,"%d\t%d\n",providerlistb[j],prependprov[j]);
}


/*

void asproviders(int source, int destination,int *providerlista,int *providerlistb, string bgprt, string provlist,FILE *filelist){

	FILE *filert;
        char bufzone1[50];
        int* tmplist;
        int i,j,k,splist,dplist,list;        

        tmplist=new int[MAXPATHLEN];
        for (j=0;j<MAXPATHLEN;j++)  tmplist[j]=0;

//providerlista[0]=source;
//providerlistb[0]=destination;

        fprintf(filelist,"%d\n",source);

        filert= fopen(bgprt.c_str(),"r");
        if (filert==NULL)
        {
            printf("the file can not be opened\n");    	exit(3);
        } else
        {
            splist=0;
            dplist=0;

            fscanf(filert,"%s", bufzone1);
            while (strcmp(bufzone1,"Path")!=0)                fscanf(filert,"%s", bufzone1);
            fscanf(filert,"%s", bufzone1);

            while (strcmp(bufzone1,"*")==0)
            {
                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);

                list=0;
                int sprepend=0;
                int dprepend=0;
                bool pforest=true;
                bool goforest=true;
                bool forest=true;
		while (goforest)
                {
                    if (strcmp(bufzone1,"i")!=0 && strcmp(bufzone1,"e")!=0 && strcmp(bufzone1,"?")!=0)
                    {
                                tmplist[list]=atoi(bufzone1);
                                fscanf(filert,"%s", bufzone1);
                                list ++;                                
                    }
                    else
                    {
                                int lastAS=tmplist[list-1];
                                list=list-1;
                                sprepend=0;                                     
                                if( lastAS == source) 
                                {
                                    while (list>0)         
                                    {
                                        while(forest)
                                        {
                                            if (lastAS!=tmplist[list-1])
                                            {
                                                for(int i=0;i<splist;i++)
                                                {
                                                    if(providerlista[i]==tmplist[list-1]) {
                                                        forest=false;pforest=false;goforest=false;
                                                        list=0;
                                                    }
                                                }
                                                if(pforest==true)
                                                {
                                                    int prepend=0;
                                                    providerlista[splist]=tmplist[list-1];
                                                    splist=splist+1;
                                                    list=0;
                                                    goforest=false;
                                                    forest=false;
                                                }
                                            }
                                            else if(goforest==true && pforest==true)
                                            {
                                                sprepend=sprepend+1;
                                                forest=true;
                                                list=list-1;
                                            }
                                        }//printf("Hello/n");getchar();
                                    }
                                }
                                goforest=false;
                                fscanf(filert,"%s",bufzone1);
                    }
                }
            }
        }
        //fprintf(filelist,"%d\n",splist);
        fclose(filert);
        fprintf(filelist,"%d\n",splist);



        filert= fopen(bgprt.c_str(),"r");
        if (filert==NULL)
        {
            printf("the file can not be opened\n");    	exit(3);
        } else {

            splist=0;
            dplist=0;

            fscanf(filert,"%s", bufzone1);
            while (strcmp(bufzone1,"Path")!=0)
                fscanf(filert,"%s", bufzone1);
            fscanf(filert,"%s", bufzone1);

            while (strcmp(bufzone1,"*")==0)
            {
                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);

                list=0;
                int sprepend=0;
                int dprepend=0;
                bool pforest=true;
                bool goforest=true;
                bool forest=true;
		while (goforest)
                {
                    if (strcmp(bufzone1,"i")!=0 && strcmp(bufzone1,"e")!=0 && strcmp(bufzone1,"?")!=0)
                    {
                                tmplist[list]=atoi(bufzone1);
                                fscanf(filert,"%s", bufzone1);
                                list ++;
                    }
                                else
                                {
                                     int lastAS=tmplist[list-1];
                                     list=list-1;
                                     int sprepend=0;
                                     if( lastAS == source)
                  {
                                    while (list>0)
                      {
                                    while(forest)
                                 {
                                       if (lastAS!=tmplist[list-1])
                                       {
                                           for(int i=0;i<splist;i++)
                                           {
                                            if(providerlista[i]==tmplist[list-1]) {forest=false;pforest=false;goforest=false;list=0;}}
                                            if(pforest==true)
                                            {
                                            int prepend=0;
                                            providerlista[splist]=tmplist[list-1];
                                            fprintf(filelist,"%d \t %d\n",providerlista[splist],sprepend);
                                            splist=splist+1;
                                            list=0;
                                            goforest=false;
                                            forest=false;
                                            }
                                       }
                                               else if(goforest==true && pforest==true)
                                     {
                                             sprepend=sprepend+1;
                                             forest=true;
                                             list=list-1;
                                     }

                                  }//printf("Hello/n");getchar();
                      }
             }                              goforest=false;
                                            fscanf(filert,"%s",bufzone1);
                                }
                }

            }
        }
fclose(filert);


fprintf(filelist,"%d\n",destination);
        filert= fopen(bgprt.c_str(),"r");
        if (filert==NULL)
        {
            printf("the file can not be opened\n");    	exit(3);
        } else {

            splist=0;
            dplist=0;

            fscanf(filert,"%s", bufzone1);
            while (strcmp(bufzone1,"Path")!=0)
                fscanf(filert,"%s", bufzone1);
            fscanf(filert,"%s", bufzone1);

            while (strcmp(bufzone1,"*")==0)
            {
                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);                fscanf(filert,"%s", bufzone1);

                list=0;
                int sprepend=0;
                int dprepend=0;
                bool pforest=true;
                bool goforest=true;
                bool forest=true;
		while (goforest)
                {
                    if (strcmp(bufzone1,"i")!=0 && strcmp(bufzone1,"e")!=0 && strcmp(bufzone1,"?")!=0)
                    {
                                tmplist[list]=atoi(bufzone1);
                                fscanf(filert,"%s", bufzone1);
                                list ++;
                    }
                                else
                                {
                                     int lastAS=tmplist[list-1];
                                     list=list-1;
                                     int dprepend=0;
                                   if( lastAS == destination)
                                  {
                                    while (list>0)
                      {
                                    while(forest)
                                 {
                                       if (lastAS!=tmplist[list-1])
                                       {
                                           for(int i=0;i<dplist;i++)
                                           {
                                            if(providerlistb[i]==tmplist[list-1]) {forest=false;pforest=false;goforest=false;list=0;}}
                                            if(pforest==true)
                                            {
                                                int prepend=0;
                                            providerlistb[dplist]=tmplist[list-1];
                                            //fprintf(filelist,"%d\t %d\n ",providerlistb[dplist],dprepend);
                                            dplist=dplist+1;
                                            list=0;
                                            goforest=false;
                                            forest=false;
                                            }
                                       }
                                               else if(goforest==true && pforest==true)
                                     {
                                             dprepend=dprepend+1;
                                             forest=true;
                                             list=list-1;
                                     }
                                  }//printf("Hello/n");getchar();
                      }
             }
                                             goforest=false;
                                            fscanf(filert,"%s",bufzone1);                                            
                }
                }
            }
        }
        //fprintf(filelist,"%d\n",dplist);
        fclose(filert);
        fprintf(filelist,"%d\n",dplist);
                
      
   filert= fopen(bgprt.c_str(),"r");
        if (filert==NULL)
        {
            printf("the file can not be opened\n");    	exit(3);
        } else {

            splist=0;
            dplist=0;

            fscanf(filert,"%s", bufzone1);
            while (strcmp(bufzone1,"Path")!=0)
                fscanf(filert,"%s", bufzone1);
            fscanf(filert,"%s", bufzone1);

            while (strcmp(bufzone1,"*")==0)
            {
                fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);
                fscanf(filert,"%s", bufzone1);

                list=0;
                int sprepend=0;
                int dprepend=0;
                bool pforest=true;
                bool goforest=true;
                bool forest=true;
		while (goforest)
                {
                    if (strcmp(bufzone1,"i")!=0 && strcmp(bufzone1,"e")!=0 && strcmp(bufzone1,"?")!=0)
                    {
                                tmplist[list]=atoi(bufzone1);
                                fscanf(filert,"%s", bufzone1);
                                list ++;
                    }
                                else
                                {
                                     int lastAS=tmplist[list-1];
                                     list=list-1;
                                     int dprepend=0;
                                   if( lastAS == destination)
                                  {
                                    while (list>0)
                      {
                                    while(forest)
                                 {
                                       if (lastAS!=tmplist[list-1])
                                       {
                                           for(int i=0;i<dplist;i++)
                                           {
                                            if(providerlistb[i]==tmplist[list-1]) {forest=false;pforest=false;goforest=false;list=0;}}
                                            if(pforest==true)
                                            {
                                                int prepend=0;
                                            providerlistb[dplist]=tmplist[list-1];
                                            fprintf(filelist,"%d\t %d\n",providerlistb[dplist],dprepend);
                                            dplist=dplist+1;
                                            list=0;
                                            goforest=false;
                                            forest=false;
                                            }
                                       }
                                               else if(goforest==true && pforest==true)
                                     {
                                             dprepend=dprepend+1;
                                             forest=true;
                                             list=list-1;
                                     }
                                  }//printf("Hello/n");getchar();
                      }
             }
                                             goforest=false;
                                            fscanf(filert,"%s",bufzone1);
                }
                }
            }
        }
        //fprintf(filelist,"%d\n",dplist);
        fclose(filert);
    }
  */
    